#ifndef __el__block_h
#define __el__block_h

#include <iostream>
#include <vector>
#include <fstream>

#include "release.h"

#include "blockaddress.h"

namespace PRJID {


class Blockpick {
	unsigned int depth;
	Blockaddress selected;
	unsigned int x,y;
public:
	Blockpick(unsigned int nx,unsigned int ny);
	void test(Blockaddress *a);
	Blockaddress result() { return selected; }
};

class Block {
	std::vector <Block> sub;
	bool active;
public:

	Block();

	bool is_splitted();
	bool is_active();

	void activate();
	void deactivate();
	void toggle();

	Block *get_child(unsigned int b);

	Block *get(Blockaddress a);
	Block *get_approx(Blockaddress a);

	Blockaddress random(Blockaddress a);


	Blockaddress top_select(unsigned int nx,unsigned int ny);


	bool top_does_collide(C3f p, float size);
	bool does_collide(C3f p,float size,Blockaddress a);

	unsigned int get_stat();
	bool frustum_test(Blockaddress a);

	void split();
	void merge();

	void check();

	void top_draw();
	void draw(Blockaddress a);


	bool top_save(std::string filename);
	bool top_load(std::string filename);
	void save(std::ofstream& st);
	void load(std::ifstream& st);

};


} //namespace

#endif
