#include "SDL_opengl.h"

#include "font_ogl.h"
#include "coordinate.h"
#include "config.h"
#include "tweak/tweak.h"


#include "help.h"

namespace PRJID {


void Help::gameplay() {
	glPushMatrix();
	glTranslatef(10,Config::dy()-Tweak::helpy_i(),0);
   static GLuint dl=0;
   if (dl!=0) { glCallList(dl); glPopMatrix(); return; }
   dl = glGenLists(1);
   glNewList(dl,GL_COMPILE);
	glColor3ub(250,250,250);

	Font_ogl::write("You are a damaged alien spy probe.");
	glTranslatef(0,14,0);
	Font_ogl::write("With visual systems malfunctioning all you have");
	glTranslatef(0,14,0);
	Font_ogl::write("left for navigation is some particle detector.");
	glTranslatef(0,14,0);
	Font_ogl::write("Reach pickup zone (blue) before system failure.");
	glTranslatef(0,14,0);
	Font_ogl::write("Don't bump into walls - you can't take much more.");
	glTranslatef(0,14,0);
	Font_ogl::write("Red bar is time left.");
	glTranslatef(0,14,0);
	Font_ogl::write("Green bar is health.");
	glTranslatef(0,14,0);
	Font_ogl::write("");
	glEndList();
	glPopMatrix();
}

void Help::mouselock() {
	glColor3f(1,1,0);
	Font_ogl::write(C3(Config::cx(),Config::cy()+60),"Click to grab mouse!",false,FA_CENTER);
}

void Help::mouselock_off() {
	glColor3f(1,1,0);
	Font_ogl::write(C3(Config::cx(),Config::cy()+60),"Mouse grabbed.",false,FA_CENTER);
	Font_ogl::write(C3(Config::cx(),Config::cy()+80),"Press 'm' if you wish to release it.",false,FA_CENTER);
}

void Help::controls() {
	glPushMatrix();
	glTranslatef(Config::cx()+10,Config::dy()-Tweak::helpy_i(),0);
   static GLuint dl=0;
   if (dl!=0) { glCallList(dl); glPopMatrix(); return; }
   dl = glGenLists(1);
   glNewList(dl,GL_COMPILE);
	glColor3ub(250,250,250);

	Font_ogl::write("'m' to toggle mouselook! 'r' to invert mouse");
	glTranslatef(0,14,0);
	Font_ogl::write("w,a,s,d or arrow keys to move.");
	glTranslatef(0,14,0);
	Font_ogl::write("Escape to quit.");
	glTranslatef(0,14,0);
	Font_ogl::write("'n' to restart game.");
	glTranslatef(0,14,0);
	Font_ogl::write("'f' to toggle fullscreen.");
	glTranslatef(0,14,0);
	Font_ogl::write("'v' to toggle audio.");
	glTranslatef(0,14,0);
	Font_ogl::write("F1 or 'h' for this help.");
	glEndList();
	glPopMatrix();
}
void Help::end() {
	glColor3ub(250,250,250);

	Font_ogl::write(C3(Config::cx(),Config::cy()-90),"You finished the game.",false,FA_CENTER);
	Font_ogl::write(C3(Config::cx(),Config::cy()-70),"Thanks for playing.",false,FA_CENTER);
	Font_ogl::write(C3(Config::cx(),Config::cy()-50),"Click to exit.",false,FA_CENTER);
}

void Help::fin() {
	glColor3ub(250,250,250);
	Font_ogl::write(C3(Config::cx(),Config::cy()-70),"Level cleared.",false,FA_CENTER);
	Font_ogl::write(C3(Config::cx(),Config::cy()-50),"Click to continue.",false,FA_CENTER);
}

void Help::paused() {
	glColor3ub(250,250,250);
	glPushMatrix();
	glScalef(2,2,2);
	glTranslatef(125,10,0);
	Font_ogl::write("game paused");
	glPopMatrix();
}

void Help::title() {
	glColor3ub(250,250,250);
	glPushMatrix();
	glScalef(2,2,2);
	glTranslatef(125,22,0);
	Font_ogl::write(FULLNAME);
	glPopMatrix();
}

void Help::gameover() {
   static GLuint dl=0;
   if (dl!=0) { glCallList(dl); return; }
   dl = glGenLists(1);
   glNewList(dl,GL_COMPILE);
	glColor3ub(250,250,250);
	glPushMatrix();
	glTranslatef(Config::cx(),Config::cy(),0);
	Font_ogl::write("        Game over       ",false,FA_CENTER);
	glTranslatef(0,14,0);
	Font_ogl::write("Click to continue",false,FA_CENTER);
	glPopMatrix();
	glEndList();
}


} //namespace
