

#include "SDL.h"
#include "SDL_opengl.h"

#include "particles.h"
#include "cube.h"
#include "random.h"
#include "util.h"

#include "part.h"

#include "tweak/tweak.h"

namespace PRJID {

   
Particle::Particle(C3f p) {
	pos=p;
	ticks=Random::sget(Tweak::particleticks_i());
	start=SDL_GetTicks();
}


bool Particles::load(std::string dir) {
	models::part::gen_dl();
	return true;
}



void Particles::add(C3f p) {
	particles_.insert(particles_.end(),Particle(p));
}




void Particles::draw() {
	std::list <Particle>::iterator it;

	Uint32 ticks;
	ticks=SDL_GetTicks();
	glEnable(GL_COLOR_MATERIAL);

	C3 color;
	C3 startcolor;

	std::list < std::list <Particle>::iterator > todelete;
	std::list < std::list <Particle>::iterator >::iterator  delit;
	float sc=Tweak::particle_scale_f();
	float radius=sc*1.5;
	for (it=particles_.begin();it!=particles_.end();it++) {
		C3f p;
		p=(*it).pos;
		p*=Tweak::blockscale_f();
		if (!Frustum::instance()->test_point(p,radius)) { 
			Frustum::instance()->notdrawn();
			//glColor3ub(250,250,250);	
			continue;
		}
		Frustum::instance()->drawn();
		glPushMatrix();
		glTranslatef(p.x,p.y,p.z);


		glScalef(sc,sc,sc);
		glTranslatef(-0.5,-0.5,-0.5);

		switch ((*it).ticks%4) {
			case 0: startcolor=Tweak::particle_color_start_color(); break;
			case 1: startcolor=Tweak::particle_color_start2_color(); break;
			case 2: startcolor=Tweak::particle_color_start3_color(); break;
			case 3: startcolor=Tweak::particle_color_start4_color(); break;
		}

		color=interpolate(
			startcolor,
			Tweak::particle_color_end_color(),
			(*it).ticks,ticks-(*it).start
		);
		glColor3ub(color.x,color.y,color.z);
		models::part::dldraw();
		glPopMatrix();
		if ((*it).ticks+(*it).start<ticks) {
			todelete.push_back(it);
		}
	}

	for (delit=todelete.begin();delit!=todelete.end();delit++) {
		particles_.erase((*delit));
	}

	glDisable(GL_COLOR_MATERIAL);
}



} //namespace
